IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'CTB_HIST_BCO'
            AND TYPE = 'P'
            AND U.UID = O.UID
            AND U.NAME = USER)
DROP PROCEDURE CTB_HIST_BCO
GO

CREATE PROCEDURE CTB_HIST_BCO(
@P_CDREDUCONT VARCHAR(3),
@P_NRMOVI VARCHAR(10),
@P_CDHISTPADR VARCHAR(4),
@P_CDEMPRESA VARCHAR(2),
@P_IDTIPO VARCHAR(1),
@P_STDSHISTPADR VARCHAR(200) OUTPUT
)

AS
BEGIN
   DECLARE  @V_STDSHISTPADR VARCHAR(200);
      /* Declarao das variveis do Cursor C_HIST*/
      DECLARE @C_HIST_DSMOVICRED VARCHAR(40);
      DECLARE @C_HIST_DSTPCREDBANC VARCHAR(30);
      DECLARE @C_HIST_NRDOCMBANC VARCHAR(10);
      DECLARE @C_HIST_NMRAZSOCCLIE VARCHAR(50);
      DECLARE @C_HIST_NMFANTCLIE VARCHAR(50);
      DECLARE @C_HIST_NMRAZSOCFORN VARCHAR(40);
      DECLARE @C_HIST_NMFANTFORN VARCHAR(40);
      DECLARE @C_HIST_DSMOVIDEBI VARCHAR(40);
      DECLARE @C_HIST_DSTPDEBIBANC VARCHAR(30);
      DECLARE @C_HIST_DSHISTTBANC VARCHAR(40);
      DECLARE @C_HIST_NRCHEQUE VARCHAR(6);

      SELECT
        @V_STDSHISTPADR =  DSHISTPADR
        FROM HISTPADR
       WHERE CDHISTPADR = @P_CDHISTPADR;

   IF  @P_IDTIPO = 'C' BEGIN

       DECLARE C_HIST CURSOR FOR
          SELECT M.DSMOVICRED, TP.DSTPCREDBANC, MB.NRDOCMBANC, C.NMRAZSOCCLIE, C.NMFANTCLIE, F.NMRAZSOCFORN, F.NMFANTFORN
            FROM  TPCREDBANC TP, MOVBANCARIO MB,
                 MOVCREDBANC M LEFT JOIN CLIENTE C ON
                                    M.CDCLIENTE = C.CDCLIENTE
                               LEFT JOIN FORNECEDOR F ON
                                    M.CDFORNECED = F.CDFORNECED

           WHERE  M.CDREDUCONT = @P_CDREDUCONT
             AND  M.NRMOVICRED = @P_NRMOVI
             AND  M.CDTPCREDBANC = TP.CDTPCREDBANC
             AND  M.CDREDUCONT = MB.CDREDUCONT
             AND  M. NRMOVBANC = MB.NRMOVBANC

       OPEN C_HIST;
       FETCH NEXT FROM C_HIST INTO @C_HIST_DSMOVICRED, @C_HIST_DSTPCREDBANC, @C_HIST_NRDOCMBANC, @C_HIST_NMRAZSOCCLIE,
                                  @C_HIST_NMFANTCLIE , @C_HIST_NMRAZSOCFORN, @C_HIST_NMFANTFORN

       WHILE (@@FETCH_STATUS = 0) BEGIN

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[DESC]', ISNULL(@C_HIST_DSMOVICRED,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[TIPO]', ISNULL(@C_HIST_DSTPCREDBANC,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[HIMB]', ISNULL(@C_HIST_DSMOVICRED +'('+@C_HIST_DSTPCREDBANC+')',''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[DOC]', ISNULL(@C_HIST_NRDOCMBANC,''));
          
          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[RSC]', ISNULL(@C_HIST_NMRAZSOCCLIE,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[NFC]', ISNULL(@C_HIST_NMFANTCLIE,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[RSF]', ISNULL(@C_HIST_NMRAZSOCFORN,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[NFF]', ISNULL(@C_HIST_NMFANTFORN,''));

          FETCH NEXT FROM C_HIST INTO @C_HIST_DSMOVICRED, @C_HIST_DSTPCREDBANC, @C_HIST_NRDOCMBANC, @C_HIST_NMRAZSOCCLIE,
                                 @C_HIST_NMFANTCLIE , @C_HIST_NMRAZSOCFORN, @C_HIST_NMFANTFORN

       END;
       CLOSE C_HIST;
       DEALLOCATE C_HIST;
   END
   ELSE IF @P_IDTIPO = 'D' BEGIN

        DECLARE C_HIST CURSOR FOR
           SELECT M.DSMOVIDEBI, TP.DSTPDEBIBANC, MB.NRDOCMBANC, C.NMRAZSOCCLIE, C.NMFANTCLIE, F.NMRAZSOCFORN, F.NMFANTFORN
            FROM  TPDEBIBANC TP, MOVBANCARIO MB,
                 MOVDEBBANC M LEFT JOIN CLIENTE C ON
                                    M.CDCLIENTE = C.CDCLIENTE
                               LEFT JOIN FORNECEDOR F ON
                                    M.CDFORNECED = F.CDFORNECED

           WHERE  M.CDREDUCONT = @P_CDREDUCONT
             AND  M.NRMOVIDEBI = @P_NRMOVI
             AND  M.CDTPDEBIBANC = TP.CDTPDEBIBANC
             AND  M.CDREDUCONT = MB.CDREDUCONT
             AND  M. NRMOVBANC = MB.NRMOVBANC

       OPEN C_HIST;
          FETCH NEXT FROM C_HIST INTO @C_HIST_DSMOVIDEBI, @C_HIST_DSTPDEBIBANC, @C_HIST_NRDOCMBANC, @C_HIST_NMRAZSOCCLIE,
                                 @C_HIST_NMFANTCLIE , @C_HIST_NMRAZSOCFORN, @C_HIST_NMFANTFORN



       WHILE (@@FETCH_STATUS = 0) BEGIN

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[DESC]', ISNULL(@C_HIST_DSMOVIDEBI,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[TIPO]', ISNULL(@C_HIST_DSTPDEBIBANC,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[HIMB]', ISNULL(@C_HIST_DSMOVIDEBI +'('+@C_HIST_DSTPDEBIBANC+')',''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[DOC]', ISNULL(@C_HIST_NRDOCMBANC,''));

          -- Mnemnico '[#CHQ]' no alterado pois na rotina antiga  substitudo por ''

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[RSC]', ISNULL(@C_HIST_NMRAZSOCCLIE,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[NFC]', ISNULL(@C_HIST_NMFANTCLIE,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[RSF]', ISNULL(@C_HIST_NMRAZSOCFORN,''));

          SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR,'[NFF]', ISNULL(@C_HIST_NMFANTFORN,''));

          FETCH NEXT FROM C_HIST INTO @C_HIST_DSMOVIDEBI, @C_HIST_DSTPDEBIBANC, @C_HIST_NRDOCMBANC, @C_HIST_NMRAZSOCCLIE,
                                 @C_HIST_NMFANTCLIE , @C_HIST_NMRAZSOCFORN, @C_HIST_NMFANTFORN

       END;
       CLOSE C_HIST;
       DEALLOCATE C_HIST;
   END
   ELSE IF @P_IDTIPO = 'T' BEGIN

      DECLARE C_HIST CURSOR FOR
         SELECT TF.DSHISTTBANC, I.NRCHEQUE
           FROM TRANSFBANC TF, ITTRANSFBANC I
          WHERE TF.CDEMPRESA  = @P_CDEMPRESA
            AND TF.NRTRANBANC = @P_NRMOVI
            AND I.CDEMPRESA = @P_CDEMPRESA
            AND I.NRTRANBANC = @P_NRMOVI

         OPEN C_HIST;
         FETCH NEXT FROM C_HIST INTO @C_HIST_DSHISTTBANC, @C_HIST_NRCHEQUE

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[HITR]', ISNULL(@C_HIST_DSHISTTBANC,''));

            SET @V_STDSHISTPADR =  REPLACE( @V_STDSHISTPADR, '[#CHQ]', ISNULL(@C_HIST_NRCHEQUE,''));

            FETCH NEXT FROM C_HIST INTO @C_HIST_DSHISTTBANC, @C_HIST_NRCHEQUE

         END;
         CLOSE C_HIST;
         DEALLOCATE C_HIST;

   END;
   SET @P_STDSHISTPADR = @V_STDSHISTPADR;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CTB_HIST_BCO','5.50.000';
GO


