var Dfs72000_EntradaDevolucoesOperadorLogistico_Controller = function(Dfs72000_EntradaDevolucoesOperadorLogistico_Service, MessageService, ScreenService, templateManager, General, localStorageEngine, ZhFilterPreferences){
    
    this.preparaFiltro = function(widget) {
        let currentRow = widget.appliedFilter.FILTER_ROW;
        widget.dataSourceFilter = Dfs72000_EntradaDevolucoesOperadorLogistico_Service.buildFilter(["CDOPERLOG", "CDFILIAL", "CDSERIE", "NRNOTAFISC"], currentRow);
        widget.dataSourceFilter.push({name: "P_DTINI", operator: "=", value: currentRow.DTENTRSAID.start});
        widget.dataSourceFilter.push({name: "P_DTFIN", operator: "=", value: currentRow.DTENTRSAID.end});
        widget.reload();

    };
    
    this.alteraReadOnlyFilhos = function(field, desbloqueiaComValor = true) {
        let widget = field.widget;
        field.filhos.forEach((filho) => {
            let filhoField = widget.getField(filho);
            filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
            if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho] = "";
            if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
            widget.getField(filho).reload();
        });
    };
    
    this.blockFieldsFilhosAndSetEvents = function(widget, filter = true) {
        let fields = widget.fields;
        fields.forEach((field) => {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "Dfs72000_EntradaDevolucoesOperadorLogistico_Controller.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                field.filhos.forEach((filho) => {
                    field = widget.getField(filho);
                    if(!field.filterProperties) widget.filterProperties = {};
                    if(filter)  field.filterProperties.readOnly = true; 
                    else  widget.getField(filho).readOnly = true; 
                });
            }
        });
    };
    
    this.openPopup = function() {
        var widgetDevolucao = templateManager.container.getWidget('dadosDevolucao');
        widgetDevolucao.currentRow.CDTIPOOPER = '';
        widgetDevolucao.currentRow.NMTIPOOPER = '';
        widgetDevolucao.currentRow.CDSERIE = '';
        widgetDevolucao.currentRow.DSSERIE = '';
        General.callRestEngine("opl#/crud/paramgeral", "FilterData", []).then((success) => {
            if(success.dataset.paramgeral[0].IDUTSERTPOP == 'S') {
                widgetDevolucao.getField('DSSERIE').isVisible = true;
                widgetDevolucao.getField('DSSERIE').readOnly  = true;
                widgetDevolucao.getField('NMTIPOOPER').events  = [{
                        "name": "FieldOnChange",
                        "code": "Dfs72000_EntradaDevolucoesOperadorLogistico_Controller.tipoOperOnChange(args.owner.field);"
                }];
            }
            else {
                widgetDevolucao.getField('DSSERIE').isVisible = false;
                widgetDevolucao.getField('NMTIPOOPER').events  = [];
            }
            
            Dfs72000_EntradaDevolucoesOperadorLogistico_Service.getDtProcessa().then(
                (data) => {
                    widgetDevolucao.currentRow.DTSAIDA = moment().format("DD/MM/YYYY");
                    widgetDevolucao.isVisible = true;
                    ScreenService.openPopup(widgetDevolucao);
                    widgetDevolucao.activate();
                }
            );
            
        });
        
    };
    
    this.tipoOperOnChange = function(field) {
        var serie = field.widget.getField('DSSERIE');
        if(field.value()) {
            serie.dataSourceFilter[0].value = field.widget.getParent().getParent().appliedFilter.FILTER_ROW.CDFILIAL;
            serie.dataSourceFilter[1].value = field.widget.currentRow.CDTIPOOPER;
            serie.readOnly  = false;
        }
        else {
            serie.readOnly  = true;
        }
    };
    
    this.closePopup = function(widget, widgetClose) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widgetClose = templateManager.container.getWidget(widgetClose);
        widgetClose.activate();
        widgetClose.reload();
        ScreenService.closePopup();
    };
    
    this.gerarDevolucao = function(widget) {
        if(widget.isValid()) {
            localStorageEngine.getDataSource('df_saida#/dadosAdic').then((success) => {
                var dadosAdicionais = success;
                var widgetNota       = templateManager.container.getWidget('devolucao_transfOpLogistico');
                var notas = widgetNota.getCheckedRows();
                var data = {
                    notas: notas,
                    dadosGeracao: widget.currentRow,
                    dadosAdicionais: dadosAdicionais
                };
                
                General.callRestEngine("df_saida#/gerarDevolucaoTransfOl", "DataSet", data).then((success) => {
                    this.closePopup(widget);
                    if(success.messages[0].message==="Não foi possível realizar a devolução das notas fiscais selecionadas."){
                        ScreenService.showMessage(success.messages[0].message);
                    }else{
                        var numNotas = success.messages[0].message;
                        var msg = "NUM_NOTAS_SUCESO";
                        MessageService.showMessageByCode(msg, {"NUMNOTAS": numNotas});
                    }
                    ScreenService.showMessage(success.messages[0].message);
                    if(success.dataset.errosDevolucao[0]) this.openPopupErros(success.dataset.errosDevolucao);
                });
            });
        }
    };
    
    this.openPopupErros = function(errosGeracao) {
        var widgetErros = templateManager.container.getWidget('errosGeracao');
        widgetErros.dataSource.data = errosGeracao;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.verificaReloadWidget = function(widget) {
        if(widget.inlineEditSave == false) widget.reload(); 
    };
    
    
    // Salvar o produto
    this.saveProdutos = function(widget) {
        widget.dataSource.data.forEach((produto) => {
            if(produto.changed) {
                if(Number(produto.QTDEVOLUCAOOL) == 0 || !produto.QTDEVOLUCAOOL ) {
                    ScreenService.showMessage("Quantidade devolvida deve ser maior que 0. " + produto.NMPRODUTO);
                }
                else if(Number(produto.QTDEVOLUCAOOL) > Number(produto.QTITEMPROD)) {
                    ScreenService.showMessage("Quantidade devolvida não pode ser maior que a quantidade original do produto. " + produto.NMPRODUTO);
                }
                else if(!produto.NMMOTIVODEV) {
                    ScreenService.showMessage("Motivo da devolução deve ser informado. " + produto.NMPRODUTO);
                }
                else {
                    General.callRestEngine("df#/crud/itemproduto/save", "Row", produto).then(function() {
                        widget.reload();
                        delete produto.changed_QTDEVOLUCAOOL;
                        delete produto.changed_NMMOTIVODEV;
                        delete produto.changed_CDMOTIVODEV;
                        delete produto.QTDEVOLUCAOOL_inline;
                        delete produto.NMMOTIVODEV_inline;
                        delete produto.CDMOTIVODEV_inline;
                        produto.changed = false;
                        widget.list();
                    });
                }
            
            }
        });
        
        
    };
    
    this.setDefaultFilter = function(widget) {
        localStorageEngine.setDataSource('opl#/crud/dadosAdic', []);
        Dfs72000_EntradaDevolucoesOperadorLogistico_Service.getFilial().then((success) => {
            var row = Util.clone(widget.currentRow);
            if(success.dataset.filial[0].IDFUNCAOFILI == 'O') {
                row.CDOPERLOG = success.dataset.filial[0].CDFILIAL;
                row.NMOPERLOG = success.dataset.filial[0].NMFILIAL;
            }
            else {
                row.CDFILIAL = success.dataset.filial[0].CDFILIAL;
                row.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            }
            var dataAtual = formatarData(new Date());
            row.DTENTRSAID = {start : dataAtual, end : dataAtual};
            
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
            console.log(error);
        });
    };
    
    this.saveDadosAdic = function(widget) {
        var existe = false;
        if(widget.isValid()) {
            localStorageEngine.getDataSource('opl#/crud/dadosAdic').then(
                (dataLocal) =>  {
                    var insertRow = {CDMENSAGEM: widget.currentRow.CDMENSAGEM, 
                                    DSMENSAGEM: widget.currentRow.DSMENSAGEM,
                                    CDFILIAL:  widget.getParent().currentRow.CDFILIAL,
                                    NRLANCTONF: widget.getParent().currentRow.NRLANCTONF
                    };
                    if(widget.currentRow.__is_new) {
                        dataLocal.map(
                            (row) => {
                                if(row.CDMENSAGEM == widget.currentRow.CDMENSAGEM && row.DSMENSAGEM == widget.currentRow.DSMENSAGEM && row.CDFILIAL   == widget.getParent().currentRow.CDFILIAL && row.NRLANCTONF   == widget.getParent().currentRow.NRLANCTONF)
                                existe = true;
                            }        
                        );
                        if(!existe) {
                            dataLocal.push(insertRow);
                        }
                    }
                    else {
                        dataLocal = dataLocal.map((row) => {
                            if(row.CDMENSAGEM == widget.backupRow.CDMENSAGEM && row.DSMENSAGEM == widget.backupRow.DSMENSAGEM && row.CDFILIAL   == widget.backupRow.CDFILIAL && row.NRLANCTONF   == widget.backupRow.NRLANCTONF) {
                                return insertRow;
                                }
                            else if(row.CDMENSAGEM == widget.currentRow.CDMENSAGEM && row.DSMENSAGEM == widget.currentRow.DSMENSAGEM && row.CDFILIAL     == widget.getParent().currentRow.CDFILIAL && row.NRLANCTONF   == widget.getParent().currentRow.NRLANCTONF) {
                                existe = true;
                            }
                            else return row;
                        });
                    }
                    if(!existe) {
                        localStorageEngine.setDataSource('opl#/crud/dadosAdic', dataLocal).then(() => {
                            ScreenService.goBack();
                            widget.reload();
                        });
                    }
                    else ScreenService.showMessage("Registro já existe.");
                }
            );
        }
    };
    
    this.deleteDadosAdic = function(widget) {
        localStorageEngine.getDataSource('opl#/crud/dadosAdic').then(
            (dataLocal) =>  {
                dataLocal = dataLocal.map((row) => {
                    if(!(row.CDMENSAGEM == widget.currentRow.CDMENSAGEM && row.DSMENSAGEM == widget.currentRow.DSMENSAGEM && row.CDFILIAL   == widget.currentRow.CDFILIAL && row.NRLANCTONF   == widget.currentRow.NRLANCTONF)) return row;
                });
                localStorageEngine.setDataSource('opl#/crud/dadosAdic', dataLocal).then(() => {
                    ScreenService.goBack();
                    widget.reload();
                });
            }
        );
    };
    
    this.limpaMensagem = function(widget) {
        var cdMensagem = widget.getField('CDMENSAGEM');
        if(cdMensagem.value()) {
            cdMensagem.setValue('');
            cdMensagem.reload();
        }
    };
    
    function formatarData(data) {
        var d = new Date(data),
        mes = '' + (d.getMonth() + 1),
        dia = '' + d.getDate(),
        ano = d.getFullYear();
    
        if (mes.length < 2) mes = '0' + mes;
        if (dia.length < 2) dia = '0' + dia;
    
        return [dia, mes, ano].join('/');
    }

    this.verificaItem = function(field, args) {
        var widget = field.widget;
        if(field.widget.currentRow.IDDEVOLVIDO == 'S') {
            widget.currentRow[field.name+'_inline'] = widget.currentRow[field.name];
            ScreenService.showMessage("Operação bloqueada. Item já utilizado para devolução do produto.");
        }
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Dfs72000_EntradaDevolucoesOperadorLogistico_Controller', Dfs72000_EntradaDevolucoesOperadorLogistico_Controller);
});
